From 9196fced4ee1c55ad104df7c5f0c55b431cfee62 Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Thu, 4 May 2017 12:58:41 +0530
Subject: [PATCH 01/18] qcacld-3.0: Update proper status for disable roam cmd

Currently, for disable roam from supplicant, if STA is in
not connected state, driver wont send any commands to FW
as it is unnecessary. However, for this case, driver
updates fail status to supplicant.

Update success status for disable roam cmd when STA is in
not connected state.

Change-Id: I076d1b5389868b5d136e5adce730f6b3ec41e6f8
CRs-Fixed: 2042596
---
 core/hdd/src/wlan_hdd_cfg80211.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

diff --git a/core/hdd/src/wlan_hdd_cfg80211.c b/core/hdd/src/wlan_hdd_cfg80211.c
index 9f3a361..98d983c 100644
--- a/core/hdd/src/wlan_hdd_cfg80211.c
+++ b/core/hdd/src/wlan_hdd_cfg80211.c
@@ -8818,6 +8818,7 @@ static int __wlan_hdd_cfg80211_set_fast_roaming(struct wiphy *wiphy,
 	int ret;
 	QDF_STATUS qdf_status;
 	unsigned long rc;
+	hdd_station_ctx_t *hdd_sta_ctx = WLAN_HDD_GET_STATION_CTX_PTR(adapter);
 
 	ENTER_DEV(dev);
 
@@ -8863,9 +8864,10 @@ static int __wlan_hdd_cfg80211_set_fast_roaming(struct wiphy *wiphy,
 				qdf_status);
 	ret = qdf_status_to_os_return(qdf_status);
 
-	INIT_COMPLETION(adapter->lfr_fw_status.disable_lfr_event);
-	if (QDF_IS_STATUS_SUCCESS(qdf_status) && !enable_lfr_fw) {
+	if (eConnectionState_Associated == hdd_sta_ctx->conn_info.connState &&
+		QDF_IS_STATUS_SUCCESS(qdf_status) && !enable_lfr_fw) {
 
+		INIT_COMPLETION(adapter->lfr_fw_status.disable_lfr_event);
 		/*
 		 * wait only for LFR disable in fw as LFR enable
 		 * is always success
-- 
1.9.1


From d50f91ea1d7e890e3fcdaaa6b298b13cf491fdcd Mon Sep 17 00:00:00 2001
From: Deepak Dhamdhere <ddhamdhe@codeaurora.org>
Date: Thu, 20 Apr 2017 17:59:58 -0700
Subject: [PATCH 02/18] qcacld-3.0: Use correct smeSessionid in rrm beacon
 report xmit

lim_send_radio_measure_report_action_frame() uses 0 as the smeSessionId
and that results in wrong value of vdev_id when firmware vdev is 1,
resulting in firmware assert. Use the value from sme session entry.

CRs-Fixed: 2036670
Change-Id: I797a719abc29d4086be131f895a90e0752a2d27f
---
 core/mac/src/pe/lim/lim_send_management_frames.c | 2 ++
 1 file changed, 2 insertions(+)

diff --git a/core/mac/src/pe/lim/lim_send_management_frames.c b/core/mac/src/pe/lim/lim_send_management_frames.c
index 75935b3..3d01cfb 100644
--- a/core/mac/src/pe/lim/lim_send_management_frames.c
+++ b/core/mac/src/pe/lim/lim_send_management_frames.c
@@ -4131,6 +4131,8 @@ lim_send_radio_measure_report_action_frame(tpAniSirGlobal pMac,
 		return eSIR_FAILURE;
 	}
 
+	smeSessionId = psessionEntry->smeSessionId;
+
 	pe_debug("dialog_token %d num_report %d",
 			dialog_token, num_report);
 
-- 
1.9.1


From 9a349c665e9b9f85875b1ec3d785460adb83ad45 Mon Sep 17 00:00:00 2001
From: Agrawal Ashish <ashishka@codeaurora.org>
Date: Tue, 9 May 2017 17:24:39 +0530
Subject: [PATCH 03/18] qcacld-3.0: Don't update MBO IEs twice

Driver should not send MBO IEs if MBO Ies come from supplicant.

Change-Id: I7ad27759ba2454465f3e204d207cb58eaf8804a9
CRs-Fixed: 2044567
---
 core/hdd/src/wlan_hdd_scan.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/core/hdd/src/wlan_hdd_scan.c b/core/hdd/src/wlan_hdd_scan.c
index e4ca4b4..617827b 100644
--- a/core/hdd/src/wlan_hdd_scan.c
+++ b/core/hdd/src/wlan_hdd_scan.c
@@ -1526,7 +1526,7 @@ static int wlan_hdd_update_scan_ies(hdd_adapter_t *adapter,
 				add_ie = true;
 			break;
 		case IE_EID_VENDOR:
-			if ((0 == qdf_mem_cmp(&temp_ie[0], MBO_OUI_TYPE,
+			if ((0 != qdf_mem_cmp(&temp_ie[0], MBO_OUI_TYPE,
 							MBO_OUI_TYPE_SIZE)) ||
 				(0 == qdf_mem_cmp(&temp_ie[0], QCN_OUI_TYPE,
 							QCN_OUI_TYPE_SIZE)))
-- 
1.9.1


From 0de961104c4f44b0efe406a8b00a15be56626373 Mon Sep 17 00:00:00 2001
From: bings <bings@codeaurora.org>
Date: Tue, 9 May 2017 05:54:55 +0800
Subject: [PATCH 04/18] qcacld-3.0: Refine HTC service connection for HTT in
 different platforms

Different HTC services should be connected based on different platforms.
HTT_DATA(2/3)_MSG_SVC are needed in ihelium, while only HTT_DATA_MSG_SVC
is needed in Rome/TF.

Change-Id: Ic36b191cd6d94255148ae6a47356ce2a149e78df
CRs-Fixed: 2043082
---
 core/dp/htt/htt.c | 38 +++++++++++++++++++++++++++++++++-----
 1 file changed, 33 insertions(+), 5 deletions(-)

diff --git a/core/dp/htt/htt.c b/core/dp/htt/htt.c
index 0cbc6e2..fe0940a 100644
--- a/core/dp/htt/htt.c
+++ b/core/dp/htt/htt.c
@@ -320,6 +320,38 @@ void htt_clear_bundle_stats(htt_pdev_handle pdev)
 }
 #endif
 
+#if defined(QCA_WIFI_3_0_ADRASTEA)
+/**
+ * htt_htc_attach_all() - Connect to HTC service for HTT
+ * @pdev: pdev ptr
+ *
+ * Return: 0 for success or error code.
+ */
+static int
+htt_htc_attach_all(struct htt_pdev_t *pdev)
+{
+	if (htt_htc_attach(pdev, HTT_DATA_MSG_SVC))
+		return -EIO;
+	if (htt_htc_attach(pdev, HTT_DATA2_MSG_SVC))
+		return -EIO;
+	if (htt_htc_attach(pdev, HTT_DATA3_MSG_SVC))
+		return -EIO;
+	return 0;
+}
+#else
+/**
+ * htt_htc_attach_all() - Connect to HTC service for HTT
+ * @pdev: pdev ptr
+ *
+ * Return: 0 for success or error code.
+ */
+static int
+htt_htc_attach_all(struct htt_pdev_t *pdev)
+{
+	return htt_htc_attach(pdev, HTT_DATA_MSG_SVC);
+}
+#endif
+
 /**
  * htt_pdev_alloc() - allocate HTT pdev
  * @txrx_pdev: txrx pdev
@@ -391,11 +423,7 @@ htt_pdev_alloc(ol_txrx_pdev_handle txrx_pdev,
 	 * since htt_rx_attach involves sending a rx ring configure
 	 * message to the target.
 	 */
-	if (htt_htc_attach(pdev, HTT_DATA_MSG_SVC))
-		goto htt_htc_attach_fail;
-	if (htt_htc_attach(pdev, HTT_DATA2_MSG_SVC))
-		goto htt_htc_attach_fail;
-	if (htt_htc_attach(pdev, HTT_DATA3_MSG_SVC))
+	if (htt_htc_attach_all(pdev))
 		goto htt_htc_attach_fail;
 	if (hif_ce_fastpath_cb_register(osc, htt_t2h_msg_handler_fast, pdev))
 		qdf_print("failed to register fastpath callback\n");
-- 
1.9.1


From 545bdd3a9cae0945dc1a6d3454a48d449f04e202 Mon Sep 17 00:00:00 2001
From: Dhanashri Atre <datre@codeaurora.org>
Date: Wed, 3 May 2017 14:56:10 -0700
Subject: [PATCH 05/18] qcacld-3.0: Fix spinlock being unlocked twice

Fix the spinlock being unlocked twice while enqueuing buffers
in the peer buffer queue.

Change-Id: I42e3a638e1789765a5103b4b775fc2d9a7822181
CRs-Fixed: 2041873
---
 core/dp/txrx/ol_txrx.c | 43 ++++++++++++++++++++++++++-----------------
 1 file changed, 26 insertions(+), 17 deletions(-)

diff --git a/core/dp/txrx/ol_txrx.c b/core/dp/txrx/ol_txrx.c
index f9822a1..5420561 100644
--- a/core/dp/txrx/ol_txrx.c
+++ b/core/dp/txrx/ol_txrx.c
@@ -4776,6 +4776,23 @@ free_buf:
 /* print for every 16th packet */
 #define OL_TXRX_PRINT_RATE_LIMIT_THRESH 0x0f
 
+/** helper function to drop packets
+ *  Note: caller must hold the cached buq lock before invoking
+ *  this function. Also, it assumes that the pointers passed in
+ *  are valid (non-NULL)
+ */
+static inline void ol_txrx_drop_frames(
+					struct ol_txrx_cached_bufq_t *bufqi,
+					qdf_nbuf_t rx_buf_list)
+{
+	uint32_t dropped = ol_txrx_drop_nbuf_list(rx_buf_list);
+	bufqi->dropped += dropped;
+	bufqi->qdepth_no_thresh += dropped;
+
+	if (bufqi->qdepth_no_thresh > bufqi->high_water_mark)
+		bufqi->high_water_mark = bufqi->qdepth_no_thresh;
+}
+
 static QDF_STATUS ol_txrx_enqueue_rx_frames(
 					struct ol_txrx_peer_t *peer,
 					struct ol_txrx_cached_bufq_t *bufqi,
@@ -4783,8 +4800,6 @@ static QDF_STATUS ol_txrx_enqueue_rx_frames(
 {
 	struct ol_rx_cached_buf *cache_buf;
 	qdf_nbuf_t buf, next_buf;
-	QDF_STATUS status = QDF_STATUS_SUCCESS;
-	int dropped = 0;
 	static uint32_t count;
 
 	if ((count++ & OL_TXRX_PRINT_RATE_LIMIT_THRESH) == 0)
@@ -4794,8 +4809,9 @@ static QDF_STATUS ol_txrx_enqueue_rx_frames(
 
 	qdf_spin_lock_bh(&bufqi->bufq_lock);
 	if (bufqi->curr >= bufqi->thresh) {
-		status = QDF_STATUS_E_FAULT;
-		goto drop_bufs;
+		ol_txrx_drop_frames(bufqi, rx_buf_list);
+		qdf_spin_unlock_bh(&bufqi->bufq_lock);
+		return QDF_STATUS_E_FAULT;
 	}
 	qdf_spin_unlock_bh(&bufqi->bufq_lock);
 
@@ -4812,32 +4828,25 @@ static QDF_STATUS ol_txrx_enqueue_rx_frames(
 			/* Add NULL terminator */
 			qdf_nbuf_set_next(buf, NULL);
 			cache_buf->buf = buf;
-			qdf_spin_lock_bh(&bufqi->bufq_lock);
 			if (peer && peer->valid) {
+				qdf_spin_lock_bh(&bufqi->bufq_lock);
 				list_add_tail(&cache_buf->list,
 				      &bufqi->cached_bufq);
 				bufqi->curr++;
 				qdf_spin_unlock_bh(&bufqi->bufq_lock);
 			} else {
-				status = QDF_STATUS_E_FAULT;
 				qdf_mem_free(cache_buf);
 				rx_buf_list = buf;
 				qdf_nbuf_set_next(rx_buf_list, next_buf);
-				goto drop_bufs;
+				qdf_spin_lock_bh(&bufqi->bufq_lock);
+				ol_txrx_drop_frames(bufqi, rx_buf_list);
+				qdf_spin_unlock_bh(&bufqi->bufq_lock);
+				return QDF_STATUS_E_FAULT;
 			}
 		}
 		buf = next_buf;
 	}
-
-drop_bufs:
-	dropped = ol_txrx_drop_nbuf_list(rx_buf_list);
-	bufqi->dropped += dropped;
-	bufqi->qdepth_no_thresh += dropped;
-
-	if (bufqi->qdepth_no_thresh > bufqi->high_water_mark)
-		bufqi->high_water_mark = bufqi->qdepth_no_thresh;
-	qdf_spin_unlock_bh(&bufqi->bufq_lock);
-	return status;
+	return QDF_STATUS_SUCCESS;
 }
 /**
  * ol_rx_data_process() - process rx frame
-- 
1.9.1


From fa964ac645336b5709d3ec92335baba577c5229c Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Thu, 11 May 2017 16:50:15 +0530
Subject: [PATCH 06/18] qcacld-3.0: Update channel info if not provided in
 FASTREASSOC command

Currently, driver is rejecting the FASTREASSOC command if the channel
is not provided as part of it (or) channel is given as zero.

Update channel from BSS description of the given BSS and honour
the FASTREASSOC command even if the channel is given zero.

Change-Id: Ie67a75fb7ccf470b95454842b7f46baa9b09d54c
CRs-Fixed: 2046547
---
 core/hdd/src/wlan_hdd_ioctl.c |  9 +++++----
 core/sme/inc/sme_api.h        |  4 +++-
 core/sme/src/common/sme_api.c | 10 ++++++++--
 3 files changed, 16 insertions(+), 7 deletions(-)

diff --git a/core/hdd/src/wlan_hdd_ioctl.c b/core/hdd/src/wlan_hdd_ioctl.c
index c853bf1..15f0974 100644
--- a/core/hdd/src/wlan_hdd_ioctl.c
+++ b/core/hdd/src/wlan_hdd_ioctl.c
@@ -840,7 +840,6 @@ void hdd_wma_send_fastreassoc_cmd(hdd_adapter_t *adapter,
 		return;
 	}
 	fastreassoc->vdev_id = adapter->sessionId;
-	fastreassoc->channel = channel;
 	fastreassoc->bssid[0] = bssid[0];
 	fastreassoc->bssid[1] = bssid[1];
 	fastreassoc->bssid[2] = bssid[2];
@@ -850,8 +849,10 @@ void hdd_wma_send_fastreassoc_cmd(hdd_adapter_t *adapter,
 
 	status = sme_get_beacon_frm(WLAN_HDD_GET_HAL_CTX(adapter), profile,
 						bssid, &fastreassoc->frame_buf,
-						&fastreassoc->frame_len);
+						&fastreassoc->frame_len,
+						&channel);
 
+	fastreassoc->channel = channel;
 	if (QDF_STATUS_SUCCESS != status) {
 		hdd_warn("sme_get_beacon_frm failed");
 		fastreassoc->frame_buf = NULL;
@@ -4445,8 +4446,8 @@ static int drv_cmd_fast_reassoc(hdd_adapter_t *adapter,
 	}
 
 	/* Check channel number is a valid channel number */
-	if (QDF_STATUS_SUCCESS !=
-		wlan_hdd_validate_operation_channel(adapter, channel)) {
+	if (channel && (QDF_STATUS_SUCCESS !=
+		wlan_hdd_validate_operation_channel(adapter, channel))) {
 		hdd_err("Invalid Channel [%d]", channel);
 		return -EINVAL;
 	}
diff --git a/core/sme/inc/sme_api.h b/core/sme/inc/sme_api.h
index c1ce085..e5c9c66 100644
--- a/core/sme/inc/sme_api.h
+++ b/core/sme/inc/sme_api.h
@@ -1510,12 +1510,14 @@ QDF_STATUS sme_get_rcpi(tHalHandle hal, struct sme_rcpi_req *rcpi);
  * @bssid: bssid to look for in scan cache
  * @frame_buf: frame buffer to populate
  * @frame_len: length of constructed frame
+ * @channel: Pointer to channel info to be filled
  *
  * Return: QDF_STATUS
  */
 QDF_STATUS sme_get_beacon_frm(tHalHandle hal, tCsrRoamProfile *profile,
 			    const tSirMacAddr bssid,
-			    uint8_t **frame_buf, uint32_t *frame_len);
+			    uint8_t **frame_buf, uint32_t *frame_len,
+			    int *channel);
 
 /**
  * sme_rso_cmd_status_cb() - Set RSO cmd status callback
diff --git a/core/sme/src/common/sme_api.c b/core/sme/src/common/sme_api.c
index 81e8335..dad4d68 100644
--- a/core/sme/src/common/sme_api.c
+++ b/core/sme/src/common/sme_api.c
@@ -17408,7 +17408,8 @@ static void sme_prepare_beacon_from_bss_descp(uint8_t *frame_buf,
 }
 QDF_STATUS sme_get_beacon_frm(tHalHandle hal, tCsrRoamProfile *profile,
 				const tSirMacAddr bssid,
-				uint8_t **frame_buf, uint32_t *frame_len)
+				uint8_t **frame_buf, uint32_t *frame_len,
+				int *channel)
 {
 	QDF_STATUS status = QDF_STATUS_SUCCESS;
 	tScanResultHandle result_handle = NULL;
@@ -17428,6 +17429,7 @@ QDF_STATUS sme_get_beacon_frm(tHalHandle hal, tCsrRoamProfile *profile,
 						profile, scan_filter);
 	if (QDF_STATUS_SUCCESS != status) {
 		sme_err("prepare_filter failed");
+		status = QDF_STATUS_E_FAULT;
 		goto free_scan_flter;
 	}
 
@@ -17448,6 +17450,7 @@ QDF_STATUS sme_get_beacon_frm(tHalHandle hal, tCsrRoamProfile *profile,
 	status = csr_scan_get_result(mac_ctx, scan_filter, &result_handle);
 	if (QDF_STATUS_SUCCESS != status) {
 		sme_err("parse_scan_result failed");
+		status = QDF_STATUS_E_FAULT;
 		goto free_scan_flter;
 	}
 
@@ -17465,7 +17468,8 @@ QDF_STATUS sme_get_beacon_frm(tHalHandle hal, tCsrRoamProfile *profile,
 	 */
 	ie_len = bss_descp->length - sizeof(tSirBssDescription)
 		+ sizeof(bss_descp->length) + sizeof(bss_descp->ieFields);
-	sme_debug("found bss_descriptor ie_len: %d", ie_len);
+	sme_debug("found bss_descriptor ie_len: %d channel %d",
+					ie_len, bss_descp->channelId);
 
 	/* include mac header and fixed params along with IEs in frame */
 	*frame_len = SIR_MAC_HDR_LEN_3A + SIR_MAC_B_PR_SSID_OFFSET + ie_len;
@@ -17478,6 +17482,8 @@ QDF_STATUS sme_get_beacon_frm(tHalHandle hal, tCsrRoamProfile *profile,
 	qdf_mem_zero(*frame_buf, *frame_len);
 	sme_prepare_beacon_from_bss_descp(*frame_buf, bss_descp, bssid, ie_len);
 
+	if (!*channel)
+		*channel = bss_descp->channelId;
 free_scan_flter:
 	/* free scan filter and exit */
 	if (scan_filter) {
-- 
1.9.1


From 499079acf65bc165a082d849abf0d8256c5f17d5 Mon Sep 17 00:00:00 2001
From: Ashwini Patil <apati@codeaurora.org>
Date: Wed, 17 May 2017 20:53:07 +0530
Subject: [PATCH 07/18] qcacld-3.0: Update current_bss in kernel after roaming
 to candidate AP

After roaming to candiadate AP, bssid is not updated in kernel
because of passing invalid arguments to ieee80211_get_channel()
and cfg80211_get_bss(). This is resulting into failure of
action frames(after reassoc) in kernel with error ENOTCONN.
So, correct the parameters for these two functions.

Change-Id: I803accb18510e3f033456ed2ff2b4f9e3a4baf33
---
 core/hdd/src/wlan_hdd_assoc.c | 25 +++++++++++++++++++++----
 core/hdd/src/wlan_hdd_main.c  |  4 ++--
 2 files changed, 23 insertions(+), 6 deletions(-)

diff --git a/core/hdd/src/wlan_hdd_assoc.c b/core/hdd/src/wlan_hdd_assoc.c
index 449909f..35f4bd8 100644
--- a/core/hdd/src/wlan_hdd_assoc.c
+++ b/core/hdd/src/wlan_hdd_assoc.c
@@ -1906,6 +1906,8 @@ static void hdd_send_re_assoc_event(struct net_device *dev,
 	uint8_t *final_req_ie = NULL;
 	tCsrRoamConnectedProfile roam_profile;
 	tHalHandle hal_handle = WLAN_HDD_GET_HAL_CTX(pAdapter);
+	int chan_no;
+	int freq;
 
 	qdf_mem_zero(&roam_profile, sizeof(roam_profile));
 
@@ -1963,8 +1965,14 @@ static void hdd_send_re_assoc_event(struct net_device *dev,
 	qdf_mem_copy(rspRsnIe, pFTAssocRsp, len);
 	qdf_mem_zero(rspRsnIe + len, IW_GENERIC_IE_MAX - len);
 
-	chan = ieee80211_get_channel(pAdapter->wdev.wiphy,
-			(int)pCsrRoamInfo->pBssDesc->channelId);
+	chan_no = pCsrRoamInfo->pBssDesc->channelId;
+	if (chan_no <= 14)
+		freq = ieee80211_channel_to_frequency(chan_no,
+						      NL80211_BAND_2GHZ);
+	else
+		freq = ieee80211_channel_to_frequency(chan_no,
+						      NL80211_BAND_5GHZ);
+	chan = ieee80211_get_channel(pAdapter->wdev.wiphy, freq);
 	sme_roam_get_connect_profile(hal_handle, pAdapter->sessionId,
 		&roam_profile);
 
@@ -2279,6 +2287,8 @@ static QDF_STATUS hdd_association_completion_handler(hdd_adapter_t *pAdapter,
 	bool hddDisconInProgress = false;
 	unsigned long rc;
 	tSirResultCodes timeout_reason = 0;
+	int chan_no;
+	int freq;
 
 	if (!pHddCtx) {
 		hdd_err("HDD context is NULL");
@@ -2528,11 +2538,18 @@ static QDF_STATUS hdd_association_completion_handler(hdd_adapter_t *pAdapter,
 								 pAdapter->sessionId);
 						hdd_debug("ft_carrier_on is %d, sending roamed indication",
 							 ft_carrier_on);
+
+						chan_no = pRoamInfo->pBssDesc->channelId;
+						if (chan_no <= 14)
+							freq = ieee80211_channel_to_frequency(chan_no,
+								  NL80211_BAND_2GHZ);
+						else
+							freq = ieee80211_channel_to_frequency(chan_no,
+								  NL80211_BAND_5GHZ);
 						chan =
 							ieee80211_get_channel
 								(pAdapter->wdev.wiphy,
-								(int)pRoamInfo->pBssDesc->
-								channelId);
+								 freq);
 						hdd_debug(
 							"assocReqlen %d assocRsplen %d",
 							assocReqlen,
diff --git a/core/hdd/src/wlan_hdd_main.c b/core/hdd/src/wlan_hdd_main.c
index 83dac08..5a97be5 100644
--- a/core/hdd/src/wlan_hdd_main.c
+++ b/core/hdd/src/wlan_hdd_main.c
@@ -4019,8 +4019,8 @@ struct cfg80211_bss *hdd_cfg80211_get_bss(struct wiphy *wiphy,
 {
 	return cfg80211_get_bss(wiphy, channel, bssid,
 				ssid, ssid_len,
-				WLAN_CAPABILITY_ESS,
-				WLAN_CAPABILITY_ESS);
+				IEEE80211_BSS_TYPE_ESS,
+				IEEE80211_PRIVACY_ANY);
 }
 #else
 struct cfg80211_bss *hdd_cfg80211_get_bss(struct wiphy *wiphy,
-- 
1.9.1


From 5d6bde4aff435a2addaa2da5a9febdc30dcda9bb Mon Sep 17 00:00:00 2001
From: Kapil Gupta <kapgupta@codeaurora.org>
Date: Tue, 9 May 2017 13:50:39 +0530
Subject: [PATCH 08/18] qcacld-3.0: Add changes to add MBO IE in assoc request

Add changes to add support for unpacking of MBO IE in association
request packet.

Change-Id: I575f718b0804e679bab31432694c97e45bd87ca0
CRs-Fixed: 2044512
---
 core/mac/src/cfg/cfgUtil/dot11f.frms           | 1 +
 core/mac/src/include/dot11f.h                  | 3 ++-
 core/mac/src/sys/legacy/src/utils/src/dot11f.c | 5 ++++-
 3 files changed, 7 insertions(+), 2 deletions(-)

diff --git a/core/mac/src/cfg/cfgUtil/dot11f.frms b/core/mac/src/cfg/cfgUtil/dot11f.frms
index 05bb351..07167ec 100644
--- a/core/mac/src/cfg/cfgUtil/dot11f.frms
+++ b/core/mac/src/cfg/cfgUtil/dot11f.frms
@@ -3267,6 +3267,7 @@ FRAME AssocRequest                        // 7.2.3.4
     OPTIE  WFDIEOpaque;
     OPTIE  vendor_vht_ie;
     OPTIE  hs20vendor_ie;
+    OPTIE  MBO_IE;
     OPTIE  QCN_IE;
 } // End frame AssocRequest.
 
diff --git a/core/mac/src/include/dot11f.h b/core/mac/src/include/dot11f.h
index 1911410..e31733b 100644
--- a/core/mac/src/include/dot11f.h
+++ b/core/mac/src/include/dot11f.h
@@ -35,7 +35,7 @@
  *
  *
  * This file was automatically generated by 'framesc'
- * Mon Apr 17 17:06:15 2017 from the following file(s):
+ * Tue May  9 13:47:22 2017 from the following file(s):
  *
  * dot11f.frms
  *
@@ -8368,6 +8368,7 @@ typedef struct sDot11fAssocRequest{
 	tDot11fIEWFDIEOpaque                  WFDIEOpaque;
 	tDot11fIEvendor_vht_ie                vendor_vht_ie;
 	tDot11fIEhs20vendor_ie                hs20vendor_ie;
+	tDot11fIEMBO_IE                       MBO_IE;
 	tDot11fIEQCN_IE                       QCN_IE;
 } tDot11fAssocRequest;
 
diff --git a/core/mac/src/sys/legacy/src/utils/src/dot11f.c b/core/mac/src/sys/legacy/src/utils/src/dot11f.c
index fdf493a..bc0fc22 100644
--- a/core/mac/src/sys/legacy/src/utils/src/dot11f.c
+++ b/core/mac/src/sys/legacy/src/utils/src/dot11f.c
@@ -33,7 +33,7 @@
  *
  *
  * This file was automatically generated by 'framesc'
- * Mon Apr 17 17:06:15 2017 from the following file(s):
+ * Tue May  9 13:47:22 2017 from the following file(s):
  *
  * dot11f.frms
  *
@@ -6643,6 +6643,9 @@ static const tIEDefn IES_AssocRequest[] = {
 	offsetof(tDot11fIEhs20vendor_ie, present), 0, "hs20vendor_ie",
 	0, 7, 9, SigIehs20vendor_ie, {80, 111, 154, 16, 0},
 	4, DOT11F_EID_HS20VENDOR_IE, 0, 0, },
+	{ offsetof(tDot11fAssocRequest, MBO_IE), offsetof(tDot11fIEMBO_IE,
+	present), 0, "MBO_IE", 0, 9, 12, SigIeMBO_IE, {80, 111, 154, 22, 0},
+	4, DOT11F_EID_MBO_IE, 0, 0, },
 	{ offsetof(tDot11fAssocRequest, QCN_IE), offsetof(tDot11fIEQCN_IE,
 	present), 0, "QCN_IE", 0, 10, 10, SigIeQCN_IE, {140, 253, 240, 1, 0},
 	4, DOT11F_EID_QCN_IE, 0, 0, },
-- 
1.9.1


From 9dd0eceaee052bcc0b304e518fd06f5870d79258 Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Thu, 4 May 2017 14:50:08 +0530
Subject: [PATCH 09/18] qcacld-3.0: Send RSO Start followed by RSO Stop for
 supplicant disabled roam

Currently, if supplicant disabled roaming, driver doesnot send RSO
cmd to fw. This causes roam invoke to fail in FW since RSO start
never happened at least once to configure roaming engine in FW.

After connection, Send RSO start followed by RSO Stop if supplicant
disabled roaming to make sure roaming engine in FW is configured
properly with required parameters at least once.

Change-Id: I72b73554b03ea3f0fa04d0da2a2db96c0ed8b1c8
CRs-Fixed: 2042629
---
 core/sme/inc/csr_neighbor_roam.h     |  2 ++
 core/sme/src/csr/csr_api_roam.c      |  6 ------
 core/sme/src/csr/csr_neighbor_roam.c | 11 +++++++++++
 3 files changed, 13 insertions(+), 6 deletions(-)

diff --git a/core/sme/inc/csr_neighbor_roam.h b/core/sme/inc/csr_neighbor_roam.h
index 586d4d2..ba39d22 100644
--- a/core/sme/inc/csr_neighbor_roam.h
+++ b/core/sme/inc/csr_neighbor_roam.h
@@ -325,6 +325,8 @@ void csr_roam_reset_roam_params(tpAniSirGlobal mac_ptr);
 #define REASON_ROAM_SCAN_STA_ROAM_POLICY_CHANGED    35
 #define REASON_ROAM_SYNCH_FAILED                    36
 #define REASON_ROAM_PSK_PMK_CHANGED                 37
+#define REASON_ROAM_STOP_ALL                        38
+#define REASON_SUPPLICANT_DISABLED_ROAMING          39
 
 
 #if defined(WLAN_FEATURE_HOST_ROAM) || defined(WLAN_FEATURE_ROAM_OFFLOAD)
diff --git a/core/sme/src/csr/csr_api_roam.c b/core/sme/src/csr/csr_api_roam.c
index 188eece..97c59a1 100644
--- a/core/sme/src/csr/csr_api_roam.c
+++ b/core/sme/src/csr/csr_api_roam.c
@@ -18522,12 +18522,6 @@ csr_roam_offload_scan(tpAniSirGlobal mac_ctx, uint8_t session_id,
 		return QDF_STATUS_E_FAILURE;
 	}
 
-	if ((ROAM_SCAN_OFFLOAD_START == command) &&
-	    (session->pCurRoamProfile &&
-	     session->pCurRoamProfile->do_not_roam)) {
-		sme_debug("Supplicant disabled driver roaming");
-		return QDF_STATUS_E_FAILURE;
-	}
 	if (0 == csr_roam_is_roam_offload_scan_enabled(mac_ctx)) {
 		sme_err("isRoamOffloadScanEnabled not set");
 		return QDF_STATUS_E_FAILURE;
diff --git a/core/sme/src/csr/csr_neighbor_roam.c b/core/sme/src/csr/csr_neighbor_roam.c
index 4d50f27..9373b69 100644
--- a/core/sme/src/csr/csr_neighbor_roam.c
+++ b/core/sme/src/csr/csr_neighbor_roam.c
@@ -1042,9 +1042,20 @@ static void csr_neighbor_roam_info_ctx_init(
 			}
 		} else
 #endif
+
 			csr_roam_offload_scan(pMac, session_id,
 				ROAM_SCAN_OFFLOAD_START,
 				REASON_CONNECT);
+
+			if (session->pCurRoamProfile &&
+				 session->pCurRoamProfile->do_not_roam) {
+				sme_debug("Supplicant disabled driver roaming");
+
+				csr_roam_offload_scan(pMac, session_id,
+					ROAM_SCAN_OFFLOAD_STOP,
+					REASON_SUPPLICANT_DISABLED_ROAMING);
+			}
+
 	}
 }
 
-- 
1.9.1


From c567768388abe5566fea2c4e368b44e3edcdd1ca Mon Sep 17 00:00:00 2001
From: Himanshu Agarwal <himanaga@codeaurora.org>
Date: Mon, 8 May 2017 14:39:35 +0530
Subject: [PATCH 10/18] qcacld-3.0: Fix implementation of some datapath
 functions

Fix implementation of some datapath functions by:
1) Change the return value of ol_tx_prepare_ll() from
   msdu list to tx desc.
2) Pass pointer of msdu info instead of msdu info structure
   in ol_tx_encap_wrapper().

Change-Id: Ibd091800e152288e6ca218416e8629879ef4839d
CRs-Fixed: 2043747
---
 core/dp/txrx/ol_tx.c | 105 +++++++++++++++++++++++++++++++++------------------
 1 file changed, 68 insertions(+), 37 deletions(-)

diff --git a/core/dp/txrx/ol_tx.c b/core/dp/txrx/ol_tx.c
index c12d72b..6236d5a 100644
--- a/core/dp/txrx/ol_tx.c
+++ b/core/dp/txrx/ol_tx.c
@@ -70,24 +70,31 @@ int ce_send_fast(struct CE_handle *copyeng, qdf_nbuf_t msdu,
  * succeeds, that guarantees that the target has room to accept
  * the new tx frame.
  */
-#define ol_tx_prepare_ll(tx_desc, vdev, msdu, msdu_info)		\
-	do {								\
-		struct ol_txrx_pdev_t *pdev = vdev->pdev;		\
-		(msdu_info)->htt.info.frame_type = pdev->htt_pkt_type;	\
-		tx_desc = ol_tx_desc_ll(pdev, vdev, msdu, msdu_info);	\
-		if (qdf_unlikely(!tx_desc)) {				\
-			/*						\
-			 * If TSO packet, free associated		\
-			 * remaining TSO segment descriptors		\
-			 */						\
-			if (qdf_nbuf_is_tso(msdu))			\
-				ol_free_remaining_tso_segs(		\
-					vdev, msdu_info, true);		\
-			TXRX_STATS_MSDU_LIST_INCR(			\
-				pdev, tx.dropped.host_reject, msdu);	\
-			return msdu; /* the list of unaccepted MSDUs */	\
-		}							\
-	} while (0)
+static struct ol_tx_desc_t *
+ol_tx_prepare_ll(ol_txrx_vdev_handle vdev,
+		 qdf_nbuf_t msdu,
+		 struct ol_txrx_msdu_info_t *msdu_info)
+{
+	struct ol_tx_desc_t *tx_desc;
+	struct ol_txrx_pdev_t *pdev = vdev->pdev;
+
+	(msdu_info)->htt.info.frame_type = pdev->htt_pkt_type;
+	tx_desc = ol_tx_desc_ll(pdev, vdev, msdu, msdu_info);
+	if (qdf_unlikely(!tx_desc)) {
+		/*
+		 * If TSO packet, free associated
+		 * remaining TSO segment descriptors
+		 */
+		if (qdf_nbuf_is_tso(msdu))
+			ol_free_remaining_tso_segs(
+					vdev, msdu_info, true);
+		TXRX_STATS_MSDU_LIST_INCR(
+				pdev, tx.dropped.host_reject, msdu);
+		return NULL;
+	}
+
+	return tx_desc;
+}
 
 #if defined(FEATURE_TSO)
 void ol_free_remaining_tso_segs(ol_txrx_vdev_handle vdev,
@@ -423,7 +430,9 @@ qdf_nbuf_t ol_tx_ll(ol_txrx_vdev_handle vdev, qdf_nbuf_t msdu_list)
 
 			segments--;
 
-			ol_tx_prepare_ll(tx_desc, vdev, msdu, &msdu_info);
+			tx_desc = ol_tx_prepare_ll(vdev, msdu, &msdu_info);
+			if (!tx_desc)
+				return msdu;
 
 			/**
 			* if this is a jumbo nbuf, then increment the number
@@ -485,7 +494,9 @@ qdf_nbuf_t ol_tx_ll(ol_txrx_vdev_handle vdev, qdf_nbuf_t msdu_list)
 
 		msdu_info.htt.info.ext_tid = qdf_nbuf_get_tid(msdu);
 		msdu_info.peer = NULL;
-		ol_tx_prepare_ll(tx_desc, vdev, msdu, &msdu_info);
+		tx_desc = ol_tx_prepare_ll(vdev, msdu, &msdu_info);
+		if (!tx_desc)
+			return msdu;
 
 		TXRX_STATS_MSDU_INCR(vdev->pdev, tx.from_stack, msdu);
 
@@ -1279,7 +1290,9 @@ ol_tx_non_std_ll(ol_txrx_vdev_handle vdev,
 		msdu_info.peer = NULL;
 		msdu_info.tso_info.is_tso = 0;
 
-		ol_tx_prepare_ll(tx_desc, vdev, msdu, &msdu_info);
+		tx_desc = ol_tx_prepare_ll(vdev, msdu, &msdu_info);
+		if (!tx_desc)
+			return msdu;
 
 		/*
 		 * The netbuf may get linked into a different list inside the
@@ -1319,20 +1332,34 @@ ol_tx_non_std_ll(ol_txrx_vdev_handle vdev,
 }
 
 #ifdef QCA_SUPPORT_SW_TXRX_ENCAP
-#define OL_TX_ENCAP_WRAPPER(pdev, vdev, tx_desc, msdu, tx_msdu_info) \
-	do { \
-		if (OL_TX_ENCAP(vdev, tx_desc, msdu, &tx_msdu_info) != A_OK) { \
-			qdf_atomic_inc(&pdev->tx_queue.rsrc_cnt); \
-			ol_tx_desc_frame_free_nonstd(pdev, tx_desc, 1);	\
-			if (tx_msdu_info.peer) { \
-				/* remove the peer reference added above */ \
-				OL_TXRX_PEER_UNREF_DELETE(tx_msdu_info.peer); \
-			} \
-			goto MSDU_LOOP_BOTTOM; \
-		} \
-	} while (0)
+static inline int ol_tx_encap_wrapper(struct ol_txrx_pdev_t *pdev,
+				      ol_txrx_vdev_handle vdev,
+				      struct ol_tx_desc_t *tx_desc,
+				      qdf_nbuf_t msdu,
+				      struct ol_txrx_msdu_info_t *tx_msdu_info)
+{
+	if (OL_TX_ENCAP(vdev, tx_desc, msdu, tx_msdu_info) != A_OK) {
+		qdf_atomic_inc(&pdev->tx_queue.rsrc_cnt);
+		ol_tx_desc_frame_free_nonstd(pdev, tx_desc, 1);
+		if (tx_msdu_info->peer) {
+			/* remove the peer reference added above */
+			OL_TXRX_PEER_UNREF_DELETE(tx_msdu_info->peer);
+		}
+		return -EINVAL;
+	}
+
+	return 0;
+}
 #else
-#define OL_TX_ENCAP_WRAPPER(pdev, vdev, tx_desc, msdu, tx_msdu_info) /* no-op */
+static inline int ol_tx_encap_wrapper(struct ol_txrx_pdev_t *pdev,
+				      ol_txrx_vdev_handle vdev,
+				      struct ol_tx_desc_t *tx_desc,
+				      qdf_nbuf_t msdu,
+				      struct ol_txrx_msdu_info_t *tx_msdu_info)
+{
+	/* no-op */
+	return 0;
+}
 #endif
 
 /* tx filtering is handled within the target FW */
@@ -1816,8 +1843,9 @@ ol_tx_hl_base(
 			 * encap, it performs encap, and if an error is
 			 * encountered, jumps to the MSDU_LOOP_BOTTOM label.
 			 */
-			OL_TX_ENCAP_WRAPPER(pdev, vdev, tx_desc, msdu,
-					    tx_msdu_info);
+			if (ol_tx_encap_wrapper(pdev, vdev, tx_desc, msdu,
+						&tx_msdu_info))
+				goto MSDU_LOOP_BOTTOM;
 
 			/* initialize the HW tx descriptor */
 			htt_tx_desc_init(
@@ -2091,7 +2119,10 @@ qdf_nbuf_t ol_tx_reinject(struct ol_txrx_vdev_t *vdev,
 	msdu_info.htt.action.tx_comp_req = 0;
 	msdu_info.tso_info.is_tso = 0;
 
-	ol_tx_prepare_ll(tx_desc, vdev, msdu, &msdu_info);
+	tx_desc = ol_tx_prepare_ll(vdev, msdu, &msdu_info);
+	if (!tx_desc)
+		return msdu;
+
 	HTT_TX_DESC_POSTPONED_SET(*((uint32_t *) (tx_desc->htt_tx_desc)), true);
 
 	htt_tx_desc_set_peer_id(tx_desc->htt_tx_desc, peer_id);
-- 
1.9.1


From 851e0f33c0f778825e0a4aa4873c6aea07871cde Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Fri, 5 May 2017 10:52:55 +0530
Subject: [PATCH 11/18] qcacld-3.0: Initialize add_ie while updating scan ie

Initialize add_ie to false to avoid the possibility of
using add_ie with random value.

Change-Id: Ic2a4dfee2961220f853e674c3dfe90707377bf24
CRs-Fixed: 2042711
---
 core/hdd/src/wlan_hdd_scan.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/core/hdd/src/wlan_hdd_scan.c b/core/hdd/src/wlan_hdd_scan.c
index 617827b..4b3a8de 100644
--- a/core/hdd/src/wlan_hdd_scan.c
+++ b/core/hdd/src/wlan_hdd_scan.c
@@ -1508,7 +1508,7 @@ static int wlan_hdd_update_scan_ies(hdd_adapter_t *adapter,
 	uint8_t *current_ie;
 	uint8_t elem_id;
 	uint16_t elem_len;
-	bool add_ie;
+	bool add_ie = false;
 
 	if (!scan_info->default_scan_ies_len || !scan_info->default_scan_ies)
 		return 0;
-- 
1.9.1


From 5e6ee7714a920848d1bc34b9dfe3f5c542abc08f Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Thu, 4 May 2017 11:23:07 +0530
Subject: [PATCH 12/18] qcacld-3.0: Update ignore_assoc_disallowed while
 creating PE session

For MBO[Multi-Band Operations], supplicant configures driver to ignore
assocition disallowed even if assoc disallowed attribute is present
in MBO IE of target BSS. Currently driver is updating this config
in PE session and fails if PE session doesnot exist at the instance.

Save ignore_assoc_disallowed config to csr roam session and update the
same to PE session while creating it via sme join request.

Change-Id: I0379c756f6150533723ba4306f9780e345c3f61f
CRs-Fixed: 2042550
---
 core/mac/inc/sir_api.h                             | 2 +-
 core/mac/src/pe/lim/lim_process_sme_req_messages.c | 3 +++
 core/sme/inc/csr_internal.h                        | 1 +
 core/sme/src/common/sme_api.c                      | 3 +++
 core/sme/src/csr/csr_api_roam.c                    | 2 ++
 5 files changed, 10 insertions(+), 1 deletion(-)

diff --git a/core/mac/inc/sir_api.h b/core/mac/inc/sir_api.h
index 4408ea4..c0fb924 100644
--- a/core/mac/inc/sir_api.h
+++ b/core/mac/inc/sir_api.h
@@ -1267,7 +1267,7 @@ typedef struct sSirSmeJoinReq {
 #endif
 	/* Pls make this as last variable in struct */
 	tSirBssDescription bssDescription;
-
+	bool ignore_assoc_disallowed;
 } tSirSmeJoinReq, *tpSirSmeJoinReq;
 
 /* / Definition for reponse message to previously issued join request */
diff --git a/core/mac/src/pe/lim/lim_process_sme_req_messages.c b/core/mac/src/pe/lim/lim_process_sme_req_messages.c
index a9a279e..27176e8 100644
--- a/core/mac/src/pe/lim/lim_process_sme_req_messages.c
+++ b/core/mac/src/pe/lim/lim_process_sme_req_messages.c
@@ -1646,6 +1646,9 @@ __lim_process_sme_join_req(tpAniSirGlobal mac_ctx, uint32_t *msg_buf)
 		session->limQosEnabled = sme_join_req->isQosEnabled;
 		session->wps_registration = sme_join_req->wps_registration;
 
+		/* Update supplicant configured ignore assoc disallowed */
+		session->ignore_assoc_disallowed =
+				sme_join_req->ignore_assoc_disallowed;
 		/* Store vendor specfic IE for CISCO AP */
 		ie_len = (bss_desc->length + sizeof(bss_desc->length) -
 			 GET_FIELD_OFFSET(tSirBssDescription, ieFields));
diff --git a/core/sme/inc/csr_internal.h b/core/sme/inc/csr_internal.h
index 99689b8..26cf8d1 100644
--- a/core/sme/inc/csr_internal.h
+++ b/core/sme/inc/csr_internal.h
@@ -982,6 +982,7 @@ typedef struct tagCsrRoamSession {
 	qdf_mc_timer_t roaming_offload_timer;
 	bool is_fils_connection;
 	uint16_t fils_seq_num;
+	bool ignore_assoc_disallowed;
 } tCsrRoamSession;
 
 typedef struct tagCsrRoamStruct {
diff --git a/core/sme/src/common/sme_api.c b/core/sme/src/common/sme_api.c
index dad4d68..f77b35f 100644
--- a/core/sme/src/common/sme_api.c
+++ b/core/sme/src/common/sme_api.c
@@ -8358,6 +8358,9 @@ QDF_STATUS sme_update_session_param(tHalHandle hal, uint8_t session_id,
 			return status;
 		}
 
+		if (param_type == SIR_PARAM_IGNORE_ASSOC_DISALLOWED)
+			session->ignore_assoc_disallowed = param_val;
+
 		if (!session->sessionActive)
 			QDF_ASSERT(0);
 
diff --git a/core/sme/src/csr/csr_api_roam.c b/core/sme/src/csr/csr_api_roam.c
index 97c59a1..17ef247 100644
--- a/core/sme/src/csr/csr_api_roam.c
+++ b/core/sme/src/csr/csr_api_roam.c
@@ -15175,6 +15175,8 @@ QDF_STATUS csr_send_join_req_msg(tpAniSirGlobal pMac, uint32_t sessionId,
 				break;
 			}
 		}
+		csr_join_req->ignore_assoc_disallowed =
+					pSession->ignore_assoc_disallowed;
 		status = cds_send_mb_message_to_mac(csr_join_req);
 		if (!QDF_IS_STATUS_SUCCESS(status)) {
 			/*
-- 
1.9.1


From 504c3c85537418f6cac3cc63a52aa8dc652bb472 Mon Sep 17 00:00:00 2001
From: Prakash Dhavali <pdhavali@codeaurora.org>
Date: Wed, 24 May 2017 23:56:41 -0700
Subject: [PATCH 13/18] Release 5.1.2.1A

Release 5.1.2.1A

Change-Id: If9a14275fbd4be2459cd01b9dca9c1fbc3554401
CRs-Fixed: 774533
---
 core/mac/inc/qwlan_version.h | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

diff --git a/core/mac/inc/qwlan_version.h b/core/mac/inc/qwlan_version.h
index 3b6ac49..1f440d5 100644
--- a/core/mac/inc/qwlan_version.h
+++ b/core/mac/inc/qwlan_version.h
@@ -40,10 +40,10 @@
 
 #define QWLAN_VERSION_MAJOR            5
 #define QWLAN_VERSION_MINOR            1
-#define QWLAN_VERSION_PATCH            1
-#define QWLAN_VERSION_EXTRA            "P"
-#define QWLAN_VERSION_BUILD            15
+#define QWLAN_VERSION_PATCH            2
+#define QWLAN_VERSION_EXTRA            "A"
+#define QWLAN_VERSION_BUILD            1
 
-#define QWLAN_VERSIONSTR               "5.1.1.15P"
+#define QWLAN_VERSIONSTR               "5.1.2.1A"
 
 #endif /* QWLAN_VERSION_H */
-- 
1.9.1


From dff11922dde53c37e4276338a162d98da1445b20 Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Fri, 26 May 2017 19:32:05 +0530
Subject: [PATCH 14/18] qcacld-3.0: Parse beacon IE's to extract Fixed fields

Currently, in beacon IE parsing of roam synch indication, fixed fields
[beacon interval, timestamp, capabilities] are not parsed resulting
in these fields being reported as zeros to supplicant.

Parse beacon IE's to extract fixed fields from beacon IE's.

Change-Id: I3ba2b8037de99a49b42eeecc7670bdb23c118f9d
CRs-Fixed: 2053019
---
 core/mac/src/include/parser_api.h                  | 13 +++++++
 core/mac/src/pe/lim/lim_api.c                      | 33 +++++++++++++++++
 core/mac/src/sys/legacy/src/utils/src/parser_api.c | 42 +++++++++++-----------
 3 files changed, 68 insertions(+), 20 deletions(-)

diff --git a/core/mac/src/include/parser_api.h b/core/mac/src/include/parser_api.h
index 38d9c2a..52d200e 100644
--- a/core/mac/src/include/parser_api.h
+++ b/core/mac/src/include/parser_api.h
@@ -1114,5 +1114,18 @@ sir_validate_and_rectify_ies(tpAniSirGlobal mac_ctx,
 				uint8_t *mgmt_frame,
 				uint32_t frame_bytes,
 				uint32_t *missing_rsn_bytes);
+/**
+ * sir_copy_caps_info() - Copy Caps info from tDot11fFfCapabilities to
+ *                        beacon/probe response structure.
+ * @mac_ctx: MAC Context
+ * @caps: tDot11fFfCapabilities structure
+ * @pProbeResp: beacon/probe response structure
+ *
+ * Copy the caps info to beacon/probe response structure
+ *
+ * Return: None
+ */
+void sir_copy_caps_info(tpAniSirGlobal mac_ctx, tDot11fFfCapabilities caps,
+			tpSirProbeRespBeacon pProbeResp);
 
 #endif /* __PARSE_H__ */
diff --git a/core/mac/src/pe/lim/lim_api.c b/core/mac/src/pe/lim/lim_api.c
index fce4d13..ce5327d 100644
--- a/core/mac/src/pe/lim/lim_api.c
+++ b/core/mac/src/pe/lim/lim_api.c
@@ -1746,6 +1746,30 @@ void lim_fill_join_rsp_ht_caps(tpPESession session, tpSirSmeJoinRsp join_rsp)
 }
 #endif
 
+/**
+ * sir_parse_bcn_fixed_fields() - Parse fixed fields in Beacon IE's
+ *
+ * @mac_ctx: MAC Context
+ * @beacon_struct: Beacon/Probe Response structure
+ * @buf: Fixed Fields buffer
+ */
+static void sir_parse_bcn_fixed_fields(tpAniSirGlobal mac_ctx,
+					tpSirProbeRespBeacon beacon_struct,
+					uint8_t *buf)
+{
+	tDot11fFfCapabilities dst;
+	beacon_struct->timeStamp[0] = lim_get_u32(buf);
+	beacon_struct->timeStamp[1] = lim_get_u32(buf + 4);
+	buf += 8;
+
+	beacon_struct->beaconInterval = lim_get_u16(buf);
+	buf += 2;
+
+	dot11f_unpack_ff_capabilities(mac_ctx, buf, &dst);
+
+	sir_copy_caps_info(mac_ctx, dst, beacon_struct);
+}
+
 #ifdef WLAN_FEATURE_ROAM_OFFLOAD
 static QDF_STATUS
 lim_roam_fill_bss_descr(tpAniSirGlobal pMac,
@@ -1802,6 +1826,15 @@ lim_roam_fill_bss_descr(tpAniSirGlobal pMac,
 			return QDF_STATUS_E_FAILURE;
 		}
 	}
+
+	/*
+	 * For probe response, unpack core parses beacon interval, capabilities,
+	 * timestamp. For beacon IEs, these fields are not parsed.
+	 */
+	if (roam_offload_synch_ind_ptr->isBeacon)
+		sir_parse_bcn_fixed_fields(pMac, parsed_frm_ptr,
+			&bcn_proberesp_ptr[SIR_MAC_HDR_LEN_3A]);
+
 	/* 24 byte MAC header and 12 byte to ssid IE */
 	if (roam_offload_synch_ind_ptr->beaconProbeRespLength >
 		(SIR_MAC_HDR_LEN_3A + SIR_MAC_B_PR_SSID_OFFSET)) {
diff --git a/core/mac/src/sys/legacy/src/utils/src/parser_api.c b/core/mac/src/sys/legacy/src/utils/src/parser_api.c
index b111a44..73c38a8 100644
--- a/core/mac/src/sys/legacy/src/utils/src/parser_api.c
+++ b/core/mac/src/sys/legacy/src/utils/src/parser_api.c
@@ -2366,6 +2366,27 @@ sir_convert_fils_data_to_probersp_struct(tpSirProbeRespBeacon probe_resp,
 }
 #endif
 
+void sir_copy_caps_info(tpAniSirGlobal mac_ctx, tDot11fFfCapabilities caps,
+					    tpSirProbeRespBeacon pProbeResp)
+{
+	pProbeResp->capabilityInfo.ess = caps.ess;
+	pProbeResp->capabilityInfo.ibss = caps.ibss;
+	pProbeResp->capabilityInfo.cfPollable = caps.cfPollable;
+	pProbeResp->capabilityInfo.cfPollReq = caps.cfPollReq;
+	pProbeResp->capabilityInfo.privacy = caps.privacy;
+	pProbeResp->capabilityInfo.shortPreamble = caps.shortPreamble;
+	pProbeResp->capabilityInfo.pbcc = caps.pbcc;
+	pProbeResp->capabilityInfo.channelAgility =	caps.channelAgility;
+	pProbeResp->capabilityInfo.spectrumMgt = caps.spectrumMgt;
+	pProbeResp->capabilityInfo.qos = caps.qos;
+	pProbeResp->capabilityInfo.shortSlotTime = caps.shortSlotTime;
+	pProbeResp->capabilityInfo.apsd = caps.apsd;
+	pProbeResp->capabilityInfo.rrm = caps.rrm;
+	pProbeResp->capabilityInfo.dsssOfdm = caps.dsssOfdm;
+	pProbeResp->capabilityInfo.delayedBA = caps.delayedBA;
+	pProbeResp->capabilityInfo.immediateBA = caps.immediateBA;
+}
+
 tSirRetStatus sir_convert_probe_frame2_struct(tpAniSirGlobal pMac,
 					      uint8_t *pFrame,
 					      uint32_t nFrame,
@@ -2407,26 +2428,7 @@ tSirRetStatus sir_convert_probe_frame2_struct(tpAniSirGlobal pMac,
 	/* Beacon Interval */
 	pProbeResp->beaconInterval = pr->BeaconInterval.interval;
 
-	/* Capabilities */
-	pProbeResp->capabilityInfo.ess = pr->Capabilities.ess;
-	pProbeResp->capabilityInfo.ibss = pr->Capabilities.ibss;
-	pProbeResp->capabilityInfo.cfPollable = pr->Capabilities.cfPollable;
-	pProbeResp->capabilityInfo.cfPollReq = pr->Capabilities.cfPollReq;
-	pProbeResp->capabilityInfo.privacy = pr->Capabilities.privacy;
-	pProbeResp->capabilityInfo.shortPreamble =
-		pr->Capabilities.shortPreamble;
-	pProbeResp->capabilityInfo.pbcc = pr->Capabilities.pbcc;
-	pProbeResp->capabilityInfo.channelAgility =
-		pr->Capabilities.channelAgility;
-	pProbeResp->capabilityInfo.spectrumMgt = pr->Capabilities.spectrumMgt;
-	pProbeResp->capabilityInfo.qos = pr->Capabilities.qos;
-	pProbeResp->capabilityInfo.shortSlotTime =
-		pr->Capabilities.shortSlotTime;
-	pProbeResp->capabilityInfo.apsd = pr->Capabilities.apsd;
-	pProbeResp->capabilityInfo.rrm = pr->Capabilities.rrm;
-	pProbeResp->capabilityInfo.dsssOfdm = pr->Capabilities.dsssOfdm;
-	pProbeResp->capabilityInfo.delayedBA = pr->Capabilities.delayedBA;
-	pProbeResp->capabilityInfo.immediateBA = pr->Capabilities.immediateBA;
+	sir_copy_caps_info(pMac, pr->Capabilities, pProbeResp);
 
 	if (!pr->SSID.present) {
 		pe_warn("Mandatory IE SSID not present!");
-- 
1.9.1


From 903074aff94fcd4c4630c1677438c44bfadce525 Mon Sep 17 00:00:00 2001
From: Kapil Gupta <kapgupta@codeaurora.org>
Date: Mon, 29 May 2017 17:29:45 +0530
Subject: [PATCH 15/18] qcacld-3.0: Change MBO IE size to support no pref
 channel list

Current MBO IE size is limited to 6 byte except length which
is not enough to contain non preferred channel list.

Add changes to increase MBO IE size.

Change-Id: I9250e7ffc8085dfe39ac62f92a831ff8d3685406
CRs-Fixed: 2053589
---
 core/mac/src/cfg/cfgUtil/dot11f.frms               |  2 +-
 core/mac/src/include/dot11f.h                      |  8 ++++----
 core/mac/src/sys/legacy/src/utils/src/dot11f.c     | 24 +++++++++++-----------
 core/mac/src/sys/legacy/src/utils/src/parser_api.c | 18 ++++++++--------
 4 files changed, 26 insertions(+), 26 deletions(-)

diff --git a/core/mac/src/cfg/cfgUtil/dot11f.frms b/core/mac/src/cfg/cfgUtil/dot11f.frms
index 07167ec..dd281a1 100644
--- a/core/mac/src/cfg/cfgUtil/dot11f.frms
+++ b/core/mac/src/cfg/cfgUtil/dot11f.frms
@@ -2450,7 +2450,7 @@ IE TimeAdvertisement (EID_TIME_ADVERTISEMENT)   // 8.4.2.63
 IE MBO_IE (EID_VENDOR_SPECIFIC) OUI ( 0x50, 0x6F, 0x9A, 0x16 )
 {
     mbo_cap[3];
-    assoc_disallowed[0..3];
+    variable_data[0..252];
 }
 
 IE QCN_IE (EID_VENDOR_SPECIFIC) OUI ( 0x8C, 0xFD, 0xF0, 0x01 )
diff --git a/core/mac/src/include/dot11f.h b/core/mac/src/include/dot11f.h
index e31733b..64518f9 100644
--- a/core/mac/src/include/dot11f.h
+++ b/core/mac/src/include/dot11f.h
@@ -35,7 +35,7 @@
  *
  *
  * This file was automatically generated by 'framesc'
- * Tue May  9 13:47:22 2017 from the following file(s):
+ * Mon May 29 15:47:41 2017 from the following file(s):
  *
  * dot11f.frms
  *
@@ -4799,8 +4799,8 @@ uint32_t dot11f_get_packed_ie_LinkIdentifier(
 typedef struct sDot11fIEMBO_IE {
 	uint8_t             present;
 	uint8_t             mbo_cap[3];
-	uint8_t             num_assoc_disallowed;
-	uint8_t             assoc_disallowed[3];
+	uint8_t             num_variable_data;
+	uint8_t             variable_data[252];
 } tDot11fIEMBO_IE;
 
 #define DOT11F_EID_MBO_IE (221)
@@ -4808,7 +4808,7 @@ typedef struct sDot11fIEMBO_IE {
 /* N.B. These #defines do *not* include the EID & length */
 #define DOT11F_IE_MBO_IE_MIN_LEN (7)
 
-#define DOT11F_IE_MBO_IE_MAX_LEN (10)
+#define DOT11F_IE_MBO_IE_MAX_LEN (259)
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/core/mac/src/sys/legacy/src/utils/src/dot11f.c b/core/mac/src/sys/legacy/src/utils/src/dot11f.c
index bc0fc22..0703ccc 100644
--- a/core/mac/src/sys/legacy/src/utils/src/dot11f.c
+++ b/core/mac/src/sys/legacy/src/utils/src/dot11f.c
@@ -33,7 +33,7 @@
  *
  *
  * This file was automatically generated by 'framesc'
- * Tue May  9 13:47:22 2017 from the following file(s):
+ * Mon May 29 15:47:41 2017 from the following file(s):
  *
  * dot11f.frms
  *
@@ -3469,13 +3469,13 @@ uint32_t dot11f_unpack_ie_MBO_IE(tpAniSirGlobal pCtx,
 	DOT11F_MEMCPY(pCtx, pDst->mbo_cap, pBuf, 3);
 	pBuf += 3;
 	ielen -= (uint8_t)3;
-	pDst->num_assoc_disallowed = (uint8_t)(ielen);
-	if (ielen > 3) {
+	pDst->num_variable_data = (uint8_t)(ielen);
+	if (ielen > 252) {
 		pDst->present = 0;
 		return DOT11F_SKIPPED_BAD_IE;
 	}
 
-	DOT11F_MEMCPY(pCtx, pDst->assoc_disallowed, pBuf, (ielen));
+	DOT11F_MEMCPY(pCtx, pDst->variable_data, pBuf, (ielen));
 	(void)pCtx;
 	return status;
 } /* End dot11f_unpack_ie_MBO_IE. */
@@ -6644,7 +6644,7 @@ static const tIEDefn IES_AssocRequest[] = {
 	0, 7, 9, SigIehs20vendor_ie, {80, 111, 154, 16, 0},
 	4, DOT11F_EID_HS20VENDOR_IE, 0, 0, },
 	{ offsetof(tDot11fAssocRequest, MBO_IE), offsetof(tDot11fIEMBO_IE,
-	present), 0, "MBO_IE", 0, 9, 12, SigIeMBO_IE, {80, 111, 154, 22, 0},
+	present), 0, "MBO_IE", 0, 9, 261, SigIeMBO_IE, {80, 111, 154, 22, 0},
 	4, DOT11F_EID_MBO_IE, 0, 0, },
 	{ offsetof(tDot11fAssocRequest, QCN_IE), offsetof(tDot11fIEQCN_IE,
 	present), 0, "QCN_IE", 0, 10, 10, SigIeQCN_IE, {140, 253, 240, 1, 0},
@@ -7066,7 +7066,7 @@ static const tIEDefn IES_Beacon[] = {
 	present), 0, "ESEVersion", 0, 7, 7, SigIeESEVersion, {0, 64, 150, 3, 0},
 	4, DOT11F_EID_ESEVERSION, 0, 0, },
 	{ offsetof(tDot11fBeacon, MBO_IE), offsetof(tDot11fIEMBO_IE, present), 0,
-	"MBO_IE", 0, 9, 12, SigIeMBO_IE, {80, 111, 154, 22, 0},
+	"MBO_IE", 0, 9, 261, SigIeMBO_IE, {80, 111, 154, 22, 0},
 	4, DOT11F_EID_MBO_IE, 0, 0, },
 	{ offsetof(tDot11fBeacon, QCN_IE), offsetof(tDot11fIEQCN_IE, present), 0,
 	"QCN_IE", 0, 10, 10, SigIeQCN_IE, {140, 253, 240, 1, 0},
@@ -7482,7 +7482,7 @@ static const tIEDefn IES_BeaconIEs[] = {
 	0, 7, 7, SigIeQComVendorIE, {0, 160, 198, 0, 0},
 	3, DOT11F_EID_QCOMVENDORIE, 0, 0, },
 	{ offsetof(tDot11fBeaconIEs, MBO_IE), offsetof(tDot11fIEMBO_IE, present),
-	0, "MBO_IE", 0, 9, 12, SigIeMBO_IE, {80, 111, 154, 22, 0},
+	0, "MBO_IE", 0, 9, 261, SigIeMBO_IE, {80, 111, 154, 22, 0},
 	4, DOT11F_EID_MBO_IE, 0, 0, },
 	{ offsetof(tDot11fBeaconIEs, QCN_IE), offsetof(tDot11fIEQCN_IE, present),
 	0, "QCN_IE", 0, 10, 10, SigIeQCN_IE, {140, 253, 240, 1, 0},
@@ -8106,7 +8106,7 @@ static const tIEDefn IES_ProbeResponse[] = {
 	0, 7, 7, SigIeESEVersion, {0, 64, 150, 3, 0},
 	4, DOT11F_EID_ESEVERSION, 0, 0, },
 	{ offsetof(tDot11fProbeResponse, MBO_IE), offsetof(tDot11fIEMBO_IE,
-	present), 0, "MBO_IE", 0, 9, 12, SigIeMBO_IE, {80, 111, 154, 22, 0},
+	present), 0, "MBO_IE", 0, 9, 261, SigIeMBO_IE, {80, 111, 154, 22, 0},
 	4, DOT11F_EID_MBO_IE, 0, 0, },
 	{ offsetof(tDot11fProbeResponse, QCN_IE), offsetof(tDot11fIEQCN_IE,
 	present), 0, "QCN_IE", 0, 10, 10, SigIeQCN_IE, {140, 253, 240, 1, 0},
@@ -13269,7 +13269,7 @@ static uint32_t get_packed_size_core(tpAniSirGlobal pCtx,
 					offset = sizeof(tDot11fIEMBO_IE);
 					byteCount = ((tDot11fIEMBO_IE *)
 					  (pFrm + pIe->offset + offset * i))->
-					  num_assoc_disallowed + 3;
+					  num_variable_data + 3;
 					pIePresent = ((tDot11fIEMBO_IE *)
 					  (pFrm + pIe->offset + offset * i))->
 					  present;
@@ -18321,7 +18321,7 @@ uint32_t dot11f_pack_ie_MBO_IE(tpAniSirGlobal pCtx,
 	uint8_t *pIeLen = 0;
 	uint32_t nConsumedOnEntry = *pnConsumed;
 	uint32_t nNeeded = 0U;
-	nNeeded  +=  (pSrc->num_assoc_disallowed + 3);
+	nNeeded  +=  (pSrc->num_variable_data + 3);
 	while (pSrc->present) {
 		if (nNeeded > nBuf)
 			return DOT11F_BUFFER_OVERFLOW;
@@ -18340,8 +18340,8 @@ uint32_t dot11f_pack_ie_MBO_IE(tpAniSirGlobal pCtx,
 		DOT11F_MEMCPY(pCtx, pBuf, pSrc->mbo_cap, 3);
 		*pnConsumed += 3;
 		pBuf += 3;
-		DOT11F_MEMCPY(pCtx, pBuf, &(pSrc->assoc_disallowed), pSrc->num_assoc_disallowed);
-		*pnConsumed += pSrc->num_assoc_disallowed;
+		DOT11F_MEMCPY(pCtx, pBuf, &(pSrc->variable_data), pSrc->num_variable_data);
+		*pnConsumed += pSrc->num_variable_data;
 		/* fieldsEndFlag = 1 */
 		break;
 	}
diff --git a/core/mac/src/sys/legacy/src/utils/src/parser_api.c b/core/mac/src/sys/legacy/src/utils/src/parser_api.c
index 73c38a8..8739085 100644
--- a/core/mac/src/sys/legacy/src/utils/src/parser_api.c
+++ b/core/mac/src/sys/legacy/src/utils/src/parser_api.c
@@ -2637,12 +2637,12 @@ tSirRetStatus sir_convert_probe_frame2_struct(tpAniSirGlobal pMac,
 		pProbeResp->MBO_IE_present = true;
 		pProbeResp->MBO_capability = pr->MBO_IE.mbo_cap[2];
 
-		if (pr->MBO_IE.num_assoc_disallowed &&
-			(pr->MBO_IE.assoc_disallowed[0] ==
+		if (pr->MBO_IE.num_variable_data &&
+			(pr->MBO_IE.variable_data[0] ==
 				 MBO_IE_ASSOC_DISALLOWED_SUBATTR_ID)) {
 			pProbeResp->assoc_disallowed = true;
 			pProbeResp->assoc_disallowed_reason =
-				pr->MBO_IE.assoc_disallowed[2];
+				pr->MBO_IE.variable_data[2];
 		}
 	}
 
@@ -3908,12 +3908,12 @@ sir_parse_beacon_ie(tpAniSirGlobal pMac,
 		pBeaconStruct->MBO_IE_present = true;
 		pBeaconStruct->MBO_capability = pBies->MBO_IE.mbo_cap[2];
 
-		if (pBies->MBO_IE.num_assoc_disallowed &&
-			(pBies->MBO_IE.assoc_disallowed[0] ==
+		if (pBies->MBO_IE.num_variable_data &&
+			(pBies->MBO_IE.variable_data[0] ==
 				 MBO_IE_ASSOC_DISALLOWED_SUBATTR_ID)) {
 			pBeaconStruct->assoc_disallowed = true;
 			pBeaconStruct->assoc_disallowed_reason =
-				pBies->MBO_IE.assoc_disallowed[2];
+				pBies->MBO_IE.variable_data[2];
 		}
 	}
 
@@ -4297,12 +4297,12 @@ sir_convert_beacon_frame2_struct(tpAniSirGlobal pMac,
 		pBeaconStruct->MBO_IE_present = true;
 		pBeaconStruct->MBO_capability = pBeacon->MBO_IE.mbo_cap[2];
 
-		if (pBeacon->MBO_IE.num_assoc_disallowed &&
-			(pBeacon->MBO_IE.assoc_disallowed[0] ==
+		if (pBeacon->MBO_IE.num_variable_data &&
+			(pBeacon->MBO_IE.variable_data[0] ==
 				 MBO_IE_ASSOC_DISALLOWED_SUBATTR_ID)) {
 			pBeaconStruct->assoc_disallowed = true;
 			pBeaconStruct->assoc_disallowed_reason =
-				pBeacon->MBO_IE.assoc_disallowed[2];
+				pBeacon->MBO_IE.variable_data[2];
 		}
 	}
 
-- 
1.9.1


From 5cd6a61a327050470bc1189d189bd738ad180770 Mon Sep 17 00:00:00 2001
From: Prakash Dhavali <pdhavali@codeaurora.org>
Date: Tue, 30 May 2017 13:33:33 -0700
Subject: [PATCH 16/18] Release 5.1.2.1B

Release 5.1.2.1B

Change-Id: I2be3cec4ad21403f77f4c9e48e19b38438bb83ea
CRs-Fixed: 774533
---
 core/mac/inc/qwlan_version.h | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/core/mac/inc/qwlan_version.h b/core/mac/inc/qwlan_version.h
index 1f440d5..89ee080 100644
--- a/core/mac/inc/qwlan_version.h
+++ b/core/mac/inc/qwlan_version.h
@@ -41,9 +41,9 @@
 #define QWLAN_VERSION_MAJOR            5
 #define QWLAN_VERSION_MINOR            1
 #define QWLAN_VERSION_PATCH            2
-#define QWLAN_VERSION_EXTRA            "A"
+#define QWLAN_VERSION_EXTRA            "B"
 #define QWLAN_VERSION_BUILD            1
 
-#define QWLAN_VERSIONSTR               "5.1.2.1A"
+#define QWLAN_VERSIONSTR               "5.1.2.1B"
 
 #endif /* QWLAN_VERSION_H */
-- 
1.9.1


From 548a17cfd0c5714d6f5d7a92f84487680c2b3bfb Mon Sep 17 00:00:00 2001
From: Manjunathappa Prakash <prakashpm@codeaurora.org>
Date: Thu, 11 May 2017 22:17:04 -0700
Subject: [PATCH 17/18] qcacld-3.0: revert back ol_rx_add_mpdu_to_list to macro

Changes done to head pointer in ol_rx_add_mpdu_to_list() is not
returned back to caller as arguments are sent as pass by value

Change-Id: Ie8c98af2ea4e03b0678df243aa0c832165494168
CRs-Fixed: 2046362
---
 core/dp/txrx/ol_rx_pn.c | 26 +++++++++++---------------
 1 file changed, 11 insertions(+), 15 deletions(-)

diff --git a/core/dp/txrx/ol_rx_pn.c b/core/dp/txrx/ol_rx_pn.c
index c387ea7..e15877d 100644
--- a/core/dp/txrx/ol_rx_pn.c
+++ b/core/dp/txrx/ol_rx_pn.c
@@ -36,19 +36,15 @@
 #include <ol_rx.h>              /* ol_rx_deliver */
 
 /* add the MSDUs from this MPDU to the list of good frames */
-static void ol_rx_add_mpdu_to_list(qdf_nbuf_t head,
-				   qdf_nbuf_t tail,
-				   qdf_nbuf_t mpdu,
-				   qdf_nbuf_t mpdu_tail)
-{
-	do {
-		if (!head)
-			head = mpdu;
-		else
-			qdf_nbuf_set_next(tail, mpdu);
-		tail = mpdu_tail;
-	} while (0);
-}
+#define ADD_MPDU_TO_LIST(head, tail, mpdu, mpdu_tail) do {		\
+		if (!head) {						\
+			head = mpdu;					\
+		} else {						\
+			qdf_nbuf_set_next(tail, mpdu);			\
+		}							\
+		tail = mpdu_tail;					\
+	} while (0)
+
 int ol_rx_pn_cmp24(union htt_rx_pn_t *new_pn,
 		   union htt_rx_pn_t *old_pn, int is_unicast, int opmode)
 {
@@ -131,7 +127,7 @@ ol_rx_pn_check_base(struct ol_txrx_vdev_t *vdev,
 
 		/* Don't check the PN replay for non-encrypted frames */
 		if (!htt_rx_mpdu_is_encrypted(pdev->htt_pdev, rx_desc)) {
-			ol_rx_add_mpdu_to_list(out_list_head, out_list_tail,
+			ADD_MPDU_TO_LIST(out_list_head, out_list_tail,
 					       mpdu, mpdu_tail);
 			mpdu = next_mpdu;
 			continue;
@@ -226,7 +222,7 @@ ol_rx_pn_check_base(struct ol_txrx_vdev_t *vdev,
 				msdu = next_msdu;
 			} while (1);
 		} else {
-			ol_rx_add_mpdu_to_list(out_list_head, out_list_tail,
+			ADD_MPDU_TO_LIST(out_list_head, out_list_tail,
 					       mpdu, mpdu_tail);
 			/*
 			 * Remember the new PN.
-- 
1.9.1


From 8b5a897c4829d1e78fd0b40010a61edf2c2f97fa Mon Sep 17 00:00:00 2001
From: Prakash Dhavali <pdhavali@codeaurora.org>
Date: Wed, 31 May 2017 16:14:40 -0700
Subject: [PATCH 18/18] Release 5.1.2.2

Release 5.1.2.2.

Change-Id: I56998409e1e27189133eb3410623cc8869caf3e4
CRs-Fixed: 774533
---
 core/mac/inc/qwlan_version.h | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

diff --git a/core/mac/inc/qwlan_version.h b/core/mac/inc/qwlan_version.h
index 89ee080..96fe129 100644
--- a/core/mac/inc/qwlan_version.h
+++ b/core/mac/inc/qwlan_version.h
@@ -41,9 +41,9 @@
 #define QWLAN_VERSION_MAJOR            5
 #define QWLAN_VERSION_MINOR            1
 #define QWLAN_VERSION_PATCH            2
-#define QWLAN_VERSION_EXTRA            "B"
-#define QWLAN_VERSION_BUILD            1
+#define QWLAN_VERSION_EXTRA            ""
+#define QWLAN_VERSION_BUILD            2
 
-#define QWLAN_VERSIONSTR               "5.1.2.1B"
+#define QWLAN_VERSIONSTR               "5.1.2.2"
 
 #endif /* QWLAN_VERSION_H */
-- 
1.9.1

